include:
  - project: 'repos/releng/kokkuri'
    file: 'includes/images.yaml'

variables:
  GIT_SUBMODULE_STRATEGY: recursive
    
stages:
- test
- build-and-publish-production-image

run-tests:
  extends: .kokkuri:build-and-run-image
  rules:
  - if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
  stage: test
  variables:
    BUILD_VARIANT: test

test-build-image:
  extends: .kokkuri:build-image
  rules:
  - if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
  stage: test
  variables:
    BUILD_VARIANT: production

# Build and publish a production image when a protected tag is created
build-and-publish-production-image:
  extends: .kokkuri:build-and-publish-image
  rules:
  - if: $CI_COMMIT_TAG && $CI_COMMIT_REF_PROTECTED
  stage: build-and-publish-production-image
  tags:
  - trusted
  variables:
    BUILD_VARIANT: production
    PUBLISH_IMAGE_TAG: $CI_COMMIT_TAG
    PUBLISH_IMAGE_EXTRA_TAGS: $KOKKURI_PIPELINE_TIMESTAMP-$BUILD_VARIANT,stable

